;; dbdraw2.scm
;; This requires the Java Advanced Imaging package (to save the images ...)

(use-module "elf/basic.scm")
(use-module "jlib/Swing.scm")

(import "javax.media.jai.JAI")


(define (for n N L)
  (if (> n N) #f 
      (begin (L n) (for (+ n 1) N L))))


(define jt (javax.swing.JTabbedPane.))

(define w 
 (window "test" 
  (border 
   (north (row 'none 'center (button "new" (action (lambda(e) (main))))))
   (center jt)
  )))


(define (main)

  (define target "hilospikers")

  (define (draw g x y t)
      (.setColor g (c-case t)) 
      (.fillRect g x y 1 1)
    )

 (define (randN N) (% (.intValue (Math.round (* N (Math.random)))) N))
 (define (randRange A B) (+ A (randN (- B A))))
 (define (randcolor) (color (randRange 100 255)(randRange 100 255)(randRange 100 255)))
 (define randColorArray (list->array java.awt.Color.class
   (let loop ((N 0)(L ())) (if (= N 1000) L (loop (+ N 1) (cons (randcolor) L))))))

 (define target-choice (choice "hilospikers" "basic" "bursters" "rand_bursters" "periods"
    (action (lambda(e) (set! target (readstring target-choice))))
   )) 


 (define (c-case x)
  (case target
   (("periods")
     (case (second x)
      ((0) white)
      ((1) (if (< (third x) 0.091) (color 0 0 255) (color 0 255 255)))
      ((2) (color (- 255 (.intValue (min 255 (max 0 (* (third x) 100))))) 0 0)) ;; 0.01 -> 2.55 seconds by steps of 0.01
      (else (color 0 (.intValue (min 255 (max 100 (* (third x) 100)))) 0))
     ))
   (("hilospikers")
     (if (not(equal? (second x) 1)) yellow (if (< (third x) 0.091) red blue)))
   (("basic") 
     (case (second x) ((0) red) ((1) blue) ((2) green) (else yellow) ))
   (("bursters")
     (if (not(equal? (second x) 2)) white
       (let ((x (max 0 (- 255 (fourth x)))))
            (color x x (- 255 x)))))
   (("rand_bursters")
     (if (not(equal? (second x) 2)) white
       (if (> (fourth x) 999) black
           (java.lang.reflect.Array.get randColorArray (fourth x)))))
   (else blue)))

  (define (c-case2 x) (case x ((0) red) ((1) blue) ((2) green) ((3) yellow) 
     (else
        (cond ((< x 10) (color 255 200 150))
              ((< x 100) (color 200 255 150))
              (else (color 0 0 100))))))

  (define (horner base L)
           (+ (first L) (* base (+ (second L) (* base (+ (third L) (* base (fourth L))))))))

  (define (dodraw g canv base L1 L2 M1 M2)
       (let* ((x (horner base (map (lambda(f) (apply f (append M1 M2))) L1)))
              (y (horner base (map (lambda(f) (apply f (append M1 M2))) L2)))
              (x1 (horner 6 M1))
              (y1 (horner 6 M2))
              (z (+ x1 (* 6 6 6 6 y1)))
             )
;         (display (list x y z))(newline)
;         (display (.get (db) z))(newline)
         (draw g x y (.get (db) z))
       )
   )


  (define stop? #f)

  (define (go g canv L1 L2)  ; L1, L2 describe the way the 8-d space is mapped to 2-d space
    (tryCatch
     (for 0 5 (lambda(n1)
     (for 0 5 (lambda(n2)
     (for 0 5 (lambda(n3)
     (for 0 5 (lambda(n4)

     (for 0 5 (lambda(n5)
     (for 0 5 (lambda(n6)
     (for 0 5 (lambda(n7)
     (for 0 5 (lambda(n8)
      (let ((p1 (list n1 n2 n3 n4))
            (p2 (list n5 n6 n7 n8))
           )
      (dodraw g canv 6 L1 L2 p1 p2)
;     (display (list 'dodraw g 6 L1 L2 p1 p2))(newline)
;     (dodraw g 6 (list n2 n1 n3 n4) (list n5 n6 n7 n8) p1 p2)
;     (dodraw g 6 (list n4 n3 n1 n2) (list n8 n7 n6 n5) p1 p2)
      (if stop? (throw (java.lang.Exception "loop halted!")))
      )))))))))
      (.repaint canv) 
      (writestring count-label {[(list n1 n2 n3 n4)]})
      ))))))))
     (lambda(e) (display {error! [e]})(newline)))
     (.repaint canv)
     (display (list 'done L1 L2))(newline)
   )



  (define the-canvas (canvas 1296 1296))
  (define (make-choice) (choice "1" "2" "3" "4" "5" "6" "7" "8"))
  (define c1 (make-choice))
  (define c2 (make-choice))
  (define c3 (make-choice))
  (define c4 (make-choice))
  (define c5 (make-choice))
  (define c6 (make-choice))
  (define c7 (make-choice))
  (define c8 (make-choice))
  (define init-cs (for-each (lambda(x y) (.setSelectedIndex x y)) (list c1 c2 c3 c4 c5 c6 c7 c8) '(0 1 2 3 4 5 6 7)))


  (define (makemap c)
    (define n (readexpr c))
    (case n
     ((1) (lambda(n1 n2 n3 n4 n5 n6 n7 n8) n1))
     ((2) (lambda(n1 n2 n3 n4 n5 n6 n7 n8) n2))
     ((3) (lambda(n1 n2 n3 n4 n5 n6 n7 n8) n3))
     ((4) (lambda(n1 n2 n3 n4 n5 n6 n7 n8) n4))
     ((5) (lambda(n1 n2 n3 n4 n5 n6 n7 n8) n5))
     ((6) (lambda(n1 n2 n3 n4 n5 n6 n7 n8) n6))
     ((7) (lambda(n1 n2 n3 n4 n5 n6 n7 n8) n7))
     ((8) (lambda(n1 n2 n3 n4 n5 n6 n7 n8) n8))
    ))

  (define go-b (button "go" (action(lambda(e) 
          (define g (.bufferg$ the-canvas))
          (define L {[ (map readstring (list c1 c2 c3 c4 c5 c6 c7 c8))]})
          (define my-canvas the-canvas)
          (.hide buttons)
          (.setTitleAt jt (.getSelectedIndex jt) {[L]})
          (set! stop? #f)
          (.setColor g (color 200 200 200))
          (.fillRect g 0 0 10000 10000)
          (.start (java.lang.Thread. (lambda() 
               (go g my-canvas (map makemap (list c1 c2 c3 c4)) (map makemap (list c5 c6 c7 c8))))))))))

  (define the-label (label ""))
  (define file-label (label ""))
  (define count-label (label ""))
  (define xy-label (label ""))
  (define data-label (label "........................................................."))
  
  (define buttons (row c1 c2 c3 c4 c5 c6 c7 c8))

  
  (define (border1)
    (border 
     (center (scrollpane the-canvas)) 
     (north 
      (col 'none 'center
        (row the-label count-label xy-label data-label)
        (row (label "save as") (textfield "" 
           (action (lambda(e) 
               (save-as-png (.buffer$ the-canvas) (readstring (.getSource e)))
               (writestring file-label (readstring (.getSource e)))
               (writestring (.getSource e) "")
            ))))
        buttons
        (row target-choice go-b 
            (button "stop" (action (lambda(e) (set! stop? #t))))
        )
      ))))
  (define the-border (border1))
  (define initbor (.add jt the-border "new-graph"))
  (.addMouseMotionListener the-canvas (jsint.Listener. (lambda(e)
     (let ((x (.getX e)) (y (.getY e)))
       (writestring xy-label {[(Integer.toString x 6)]:[(Integer.toString y 6)]          })))))
  (.setSelectedComponent jt the-border)
  (.pack w) (.show w)
;  w
)


(define (save-as-png image file)
  (javax.media.jai.JAI.create "filestore" image file "png"))


(define legend
{
c8=INa, c7=ICaT, c6=ICaS, c5=IA, c4=IKCa, c3=IKd, c2=IH, c1=Ileak

c8 Conductance level for INa. Multiplied by 100 mS/cm2, 
     this number gives the maximal conductance density of INa in this neuron.

c7 Conductance level for ICaT. Multiplied by 2.5 mS/cm2, 
     this number gives the maximal conductance density of ICaT in this neuron.

c6 Conductance level for ICaS. Multiplied by 2 mS/cm2, 
     this number gives the maximal conductance density of ICaS in this neuron.

c5 Conductance level for IA. Multiplied by 10 mS/cm2, 
    this number gives the maximal conductance density of IA in this neuron.

c4 Conductance level for IKCa. Multiplied by 5 mS/cm2, 
    this number gives the maximal conductance density of IKCa in this neuron.

c3 Conductance level for IKd. Multiplied by 25 mS/cm2, 
    this number gives the maximal conductance density of IKd in this neuron.

c2 Conductance level for IH. Multiplied by 0.01 mS/cm2, 
    this number gives the maximal conductance density of IH in this neuron.

c1 Conductance level for Ileak. Multiplied by 0.01 mS/cm2, 
    this number gives the maximal conductance density of Ileak in this neuron.

})


  (.pack w) (.show w)

